<?php

namespace App\Controllers\Admin;

use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;

use CodeIgniter\HTTP\ResponseInterface;
use CodeIgniter\Validation\Validation;
use Psr\Log\LoggerInterface;

use App\Helpers\UserHelper;
use App\Services\UserService;

class UserController extends AdminController
{
    private $_db;
    private $_service = null;
    private $_helper = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->content_title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;
        $this->_db = \Config\Database::connect();
    }
    final public function getService(): UserService
    {
        if (!$this->_service) {
            $this->_service = new UserService();
        }
        return $this->_service;
    }
    public function getHelper(): UserHelper
    {
        if (!$this->_helper) {
            $this->_helper = new UserHelper();
        }
        return $this->_helper;
    }
    //Index,FieldForm관련
    protected function getResultSuccess_process(string $message = MESSAGES["SUCCESS"], ?string $actionTemplate = null): RedirectResponse|string
    {
        switch ($this->getAction()) {
            case 'profile_modify':
                $this->getMyLogService()->save($this->getService()->getClassName(), $this->getAction(), $message, $this->getMyAuth()->getUIDByAuthInfo());
                $result = $this->view($this->entity->getPK());
                break;
            case 'profile_modify_form':
                $this->control = $this->getControlDatas();
                $this->getHelper()->setViewDatas($this->getViewDatas());
                $actionTemplate = $this->request->getVar('ActionTemplate') ?? $actionTemplate;
                if ($actionTemplate) {
                    $view_file = $this->view_path . $actionTemplate . DIRECTORY_SEPARATOR . 'modify_form';
                } else {
                    $view_file = $this->view_path . 'modify_form';
                }
                $result = view($view_file, ['viewDatas' => $this->getViewDatas()]);
                break;
            default:
                $result = parent::getResultSuccess_process($message, $actionTemplate);
                break;
        }
        return $result;
    }
    protected function doValidation_process(Validation $validation, string $field, string $rule): Validation
    {
        switch ($field) {
            case 'role':
                //아래 Rule Array는 필드명.* checkbox를 사용
                $validation->setRule("{$field}.*", $field, $rule);
                break;
            default:
                $validation = parent::doValidation_process($validation, $field,  $rule);
                break;
        }
        return $validation;
    }
    //Index,FieldForm관련.
    final public function profile_modify_form(mixed $uid): RedirectResponse|string
    {
        try {
            //각 Field 초기화
            $this->setAction(__FUNCTION__);
            $this->initAction([
                'fields' => ['id', 'passwd', 'confirmpassword', 'name', 'email', 'mobile'],
            ]);
            helper(['form']);
            //기존 Entity 가져오기
            $entity = $this->getService()->getEntity($uid);
            if (!$entity) {
                throw new \Exception("{$uid}에 대한 정보를 찾을수 없습니다.");
            }
            $this->modify_form_process($entity);
            $this->forms = ['attributes' => ['method' => "post",], 'hiddens' => []];
            return $this->getResultSuccess_process();
        } catch (\Exception $e) {
            return $this->getResultFail_process($e->getMessage());
        }
    }
    final public function profile_modify(int $uid): RedirectResponse|string
    {
        //Transaction Start
        $this->_db->transStart();
        try {
            //각 Field 초기화
            $this->setAction(__FUNCTION__);
            $this->initAction([
                'fields' => ['id', 'passwd', 'confirmpassword', 'name', 'email', 'mobile'],
            ]);
            //전달값받기
            $formDatas = $this->getFormDatas($this->getControlDatas('actionFields'), $this->request->getPost());
            //기존 Entity 가져오기
            $entity = $this->getService()->getEntity($uid);
            if (!$entity) {
                throw new \Exception("{$uid}에 대한 정보를 찾을수 없습니다.");
            }
            $this->modify_process($entity,  $formDatas);
            $this->_db->transCommit();
            return $this->getResultSuccess_process();
        } catch (\Exception $e) {
            $this->_db->transRollback();
            return $this->getResultFail_process($e->getMessage());
        }
    }
}
